
	global _enc_base91, _dec_base91

	section .text
	align 1

_enc_base91           ; void enc_base91(byte *p, dword *bin);

	xgey              ; p in IY
	xgdx              ; bin
	lde  0,x
	ldd  2,x          ; *bin in ED

	ldx  # 91 * 91
	ediv              ; ED / IX to IX, remainder to D
	xgex              ; save MSpart in E
	bsr  L0           ; do LSpart
	aiy  #-2          ; offset 'p' to MSpart bytes
	xgde              ; do MSpart from E
L0
	ldx  # 91
	idiv              ; D / IX to IX, remainder to D
	addb # '!'
	stab 3,y
	xgdx
	addb # '!'
	stab 2,y
	rts

_dec_base91           ; bool dec_base91(byte *p, dword *bin_result);

	xgey              ; p in IY
	xgdx              ; bin in IX, used as an intermediate scratch

	ldd  2,y
	bsr  half         ; p[2] and p[3]
	std  2,x          ; tmp
	ldd  0,y
	bsr  half         ; p[0] and p[1]

	lde  # 91 * 91
	emul              ; ED = E * D
	addd 2,x
	adce # 0          ; binary result

	ste  0,x
	std  2,x          ; in place
	ldd  # 1
	rts               ; TRUE

bad
	ais  #+4          ; purge subroutine call
	clrd
	rts               ; FALSE	

half
	subd # '!!'
	cmpa # 91
	bcc  bad          ; outside allowed range
	cmpb # 91
	bcc  bad

	stab 0,x          ; tmp
	ldab # 91
	mul               ; D = A * B
	addb 0,x
	adca # 0
	rts

