
FF equ 0FFh

; MC68HC16Z1

; SIM

SIMCR   equ 0FA00h  ; W configuration
SYNCR   equ 0FA04h  ; W clock synthesizer control
RSR     equ 0FA07h  ; B reset status
PORTE   equ 0FA11h  ; B PORT E data
DDRE    equ 0FA15h  ; B PORT E direction
PEPAR   equ 0FA17h  ; B PORT E pin assignment
PORTF   equ 0FA19h  ; B PORT F data
DDRF    equ 0FA1Dh  ; B PORT F direction
PFPAR   equ 0FA1Fh  ; B PORT F pin assignment
SYPCR   equ 0FA21h  ; B system protection control
PICR    equ 0FA22h  ; W periodic interrupt control
PITR    equ 0FA24h  ; W periodic interrupt timing
SWSR    equ 0FA27h  ; B watchdog service
PORTC   equ 0FA41h  ; B PORT C data
CSPAR0  equ 0FA44h  ; W chip-select pin assignment register 0
CSPAR1  equ 0FA46h  ; W chip-select pin assignment register 1
CSBARBT equ 0FA48h  ; W chip-select boot base address
CSORBT  equ 0FA4Ah  ; W chip-select boot option
CSBAR0  equ 0FA4Ch  ; W chip-select 0 base address
CSOR0   equ 0FA4Eh  ; W chip select 0 option
CSBAR1  equ 0FA50h  ; W chip-select 1 base address
CSOR1   equ 0FA52h  ; W chip-select 1 option
CSBAR2  equ 0FA54h  ; W chip-select 2 base address
CSOR2   equ 0FA56h  ; W chip-select 2 option
CSBAR3  equ 0FA58h  ; W chip-select 3 base address
CSOR3   equ 0FA5Ah  ; W chip-select 3 option
CSBAR4  equ 0FA5Ch  ; W chip-select 4 base address
CSOR4   equ 0FA5Eh  ; W chip-select 4 option
CSBAR5  equ 0FA60h  ; W chip-select 5 base address
CSOR5   equ 0FA62h  ; W chip-select 5 option
CSBAR6  equ 0FA64h  ; W chip-select 6 base address
CSOR6   equ 0FA66h  ; W chip-select 6 option
CSBAR7  equ 0FA68h  ; W chip-select 7 base address
CSOR7   equ 0FA6Ah  ; W chip-select 7 option
CSBAR8  equ 0FA6Ch  ; W chip-select 8 base address
CSOR8   equ 0FA6Eh  ; W chip-select 8 option
CSBAR9  equ 0FA70h  ; W chip-select 9 base address
CSOR9   equ 0FA72h  ; W chip-select 9 option
CSBAR10 equ 0FA74h  ; W chip-select 10 base address
CSOR10  equ 0FA76h  ; W chip-select 10 option

; SRAM

RAMMCR  equ 0FB00h  ; W configuration
RAMBAH  equ 0FB04h  ; W RAM base address high
RAMBAL  equ 0FB06h  ; W RAM base address low

; ADC

ADCMCR  equ 0F700h  ; W configuration
PORTADA equ 0F707h  ; B PORT ADA data
ADCTL0  equ 0F70Ah  ; W control 0
ADCTL1  equ 0F70Ch  ; W control 1
ADCSTAT equ 0F70Eh  ; W status
RJURR0  equ 0F710h  ; W right justified unsigned result 0
RJURR1  equ 0F712h  ;
RJURR2  equ 0F714h  ;
RJURR3  equ 0F716h  ;
RJURR4  equ 0F718h  ;
RJURR5  equ 0F71Ah  ;
RJURR6  equ 0F71Ch  ;
RJURR7  equ 0F71Eh  ;
LJSRR0  equ 0F720h  ; W left justified signed result 0
LJSRR1  equ 0F722h  ;
LJSRR2  equ 0F724h  ;
LJSRR3  equ 0F726h  ;
LJSRR4  equ 0F728h  ;
LJSRR5  equ 0F72Ah  ;
LJSRR6  equ 0F72Ch  ;
LJSRR7  equ 0F72Eh  ;
LJURR0  equ 0F730h  ; W left justified unsigned result 0
LJURR1  equ 0F732h  ;
LJURR2  equ 0F734h  ;
LJURR3  equ 0F736h  ;
LJURR4  equ 0F738h  ;
LJURR5  equ 0F73Ah  ;
LJURR6  equ 0F73Ch  ;
LJURR7  equ 0F73Eh  ;

; QSM

QMCR    equ 0FC00h  ; W configuration
QILR    equ 0FC04h  ; B QSM interrupt level
QIVR    equ 0FC05h  ; B QSM interrupt vector
SCCR0   equ 0FC08h  ; W SCI control 0
SCCR1   equ 0FC0Ah  ; W SCI control 1
SCSR    equ 0FC0Ch  ; W SCI status
SCDR    equ 0FC0Eh  ; W SCI data
PORTQS  equ 0FC15h  ; B PORT QS data
QSPAR   equ 0FC16h  ; B PORT QS pin assignment
DDRQS   equ 0FC17h  ; B PORT QS direction
SPCR0   equ 0FC18h  ; W QSPI control 0
SPCR1   equ 0FC1Ah  ; W QSPI control 1
SPCR2   equ 0FC1Ch  ; W QSPI control 2
SPCR3   equ 0FC1Eh  ; B QSPI control 3
SPSR    equ 0FC1Fh  ; B QSPI status
RRAM    equ 0FD00h  ; W*16 receive RAM
TRAM    equ 0FD20h  ; W*16 transmit RAM
CRAM    equ 0FD40h  ; B*16 command RAM

; GPT

GPTMCR  equ 0F900h  ; W configuration
ICR     equ 0F904h  ; W GPT interrupt configuration
DDRGP   equ 0F906h  ; B PORT GP direction
PORTGP  equ 0F907h  ; B PORT GP data
OC1M    equ 0F908h  ; B OC1 action mask
OC1D    equ 0F909h  ; B OC1 action data
TCNT    equ 0F90Ah  ; W timer counter
PACTL   equ 0F90Ch  ; B pulse accumulator control
PACNT   equ 0F90Dh  ; B pulse accumulator counter
TIC1    equ 0F90Eh  ; W input capture register 1
TIC2    equ 0F910h  ;
TIC3    equ 0F912h  ;
TOC1    equ 0F914h  ; W output compare register 1
TOC2    equ 0F916h  ;
TOC3    equ 0F918h  ;
TOC4    equ 0F91Ah  ;
TI4O5   equ 0F91Ch  ; W input capture 4 or output compare 5
TCTL1   equ 0F91Eh  ; B timer control 1
TCTL2   equ 0F91Fh  ; B timer control 2
TMSK1   equ 0F920h  ; B timer interrupt mask 1
TMSK2   equ 0F921h  ; B timer interrupt mask 2
TFLG1   equ 0F922h  ; B timer interrupt flag 1
TFLG2   equ 0F923h  ; B timer interrupt flag 2
CFORC   equ 0F924h  ; B compare force
PWMC    equ 0F925h  ; B PWM control
PWMA    equ 0F926h  ; B PWM A
PWMB    equ 0F927h  ; B PWM B
PWMCNT  equ 0F928h  ; W PWM counter
PWMBUFA equ 0F92Ah  ; B PWM buffer register A
PWMBUFB equ 0F92Bh  ; B PWM buffer register B
PRESCL  equ 0F92Ch  ; W GPT prescaler

