
PCF8574 equ 4Ch

	section .bss
	align   1

inputs ds.b 1          ; always 0F or F0, after first i2c_poll()
       ds.b 1          ; align

	section .text
	align   1

	global _kp2_poll


inputs_update
	lde  # 1           ; i2c_wr(,, 1);
	pshm e
	ldd  # inputs
	lde  # PCF8574
	jsr  _i2c_wr
	ais  #+2
	rts

read                   ; return onebits in B, for each active row (or column)
	lde  # 1           ; i2c_rd(,, 1);
	pshm d,e           ; d goes first, byte buf[2]
	tsx
	xgdx
	addd # 3           ; &buf[1]
	lde  # PCF8574
	jsr  _i2c_rd
	tstd               ; 'not equals' if TRUE return
	pulm d,e           ; b gets the byte read. ccr kept.
	bne  L0
	ldab # ~0          ; fake idle bits, if read error
L0
	comb
	andb inputs        ; invert and extract, 'equals' and B=0 if none active.
	rts


_kp2_poll
	tst  inputs        ; first time here ?
	bne  L1
	ldab # 0Fh         ; start by watching rows
	stab inputs
	bsr  inputs_update
L1
	jsr  _read_PORTF
	bitb # 1           ; MODCLK
	bne  ret           ; /INT is idle "1", no changes

	bsr  read          ; rows (or cols) to B, positive logic
	beq  nokey         ; all were 1111
	pshm d

	com  inputs        ; flip input and output side
	bsr  inputs_update

	bsr  read          ; cols (or rows)
	beq  nokey         ; all were 1111
	pulm e
	ade                ; E has row and column bits in positive logic
	ted
	ande # 00Fh        ; E has rows
	andb # 0F0h        ; B has columns

	ldx  # _keymap - 5 ; loops below increment 4 + 1 too many times
L2
	aix  #+4
	lsre               ; bit number counting from right
	bcc  L2
	bne  ret           ; more than one row active, do nothing yet
L3
	aix  #+1
	aslb               ; bit number counting from left
	bcc  L3
	bne  ret           ; more than one column active, do nothing yet

	ldab 0,x
	cmpb _keydown      ; glitch or grounded /INT, probably.
	beq  ret           ; no repeat action.
	stab _key          ; store key at 'make' only
nokey
	stab _keydown      ; 0 == NoKey or currently pressed key
ret
	rts

