
#include "standard.h"
#include "hamdr_cfg.h"
#include "fix.h"

struct hotspot {
	long lat, lon;      /* center */
	word radius;        /* meters. RECTANGLE, not circle */
	word hyst;
	dword rfu;
}
	hotspots[10];

STATIC bool inside[__SIZEOF(cfg.hotspots)];

static word
lat_meters_to(long *lat)
{
	dword m = lat_mm_to_m(labs(*lat - gps.coord.lat));

	return ((m > WORD_MAX) ? WORD_MAX : m);
}

static word
lon_meters_to(long *lon)
{
	dword m = lon_mm_to_m(labs(*lon - gps.coord.lon));

	return ((m > WORD_MAX) ? WORD_MAX : m);
}

/* has 'gps' crossed any hotspots XXX generalize 'gps' with an argument */

/* maybe do one hotspot per call, successive, wrapping,
 * to conserve resources */

bool
hotspots_crossed_any()
{
	struct hotspot *p = cfg.hotspots;
	bool *in = inside;
	bool any = FALSE;

	do {
		word meters = p->radius;

		if (meters) {
			if (*in) {
				meters += p->hyst;

				if (lat_meters_to(&p->lat) > meters
				 || lon_meters_to(&p->lon) > meters) {
					any = TRUE;
					*in = FALSE;
				}
			} else {
				if (lat_meters_to(&p->lat) <= meters
				 && lon_meters_to(&p->lon) <= meters) {
					any = TRUE;
					*in = TRUE;
				}
			}
		}
		++in;
	} while (++p < __ENDOF(cfg.hotspots));

	return (any);
}

void
hotspot_cmd(byte *arg)
{
	struct hotspot *p;
	word n;
	byte *rad, *comma;

	if (*arg == 0) {
show:
		for (p = cfg.hotspots; p < __ENDOF(cfg.hotspots); ++p)
			if (p->radius) {
				print_string("hotspot ");
				print_short(p - cfg.hotspots);
				blank();
				print_short(p->radius);
				print_string("+");
				print_short(p->hyst);
				blank();
				print_coords(&p->lat);
				eol();
			}
		return;
	}

	/* hotspot 3 100+50m 6059.99N,2859.99E */

	n = atoi(blanksplit(&arg));

	rad = blanksplit(&arg);
	comma = index(arg, COMMA);

	if (n >= __SIZEOF(hotspots))
		goto show;

	p = &cfg.hotspots[n];

	p->radius = atoi(rad);
	if (rad = index(rad, '+'))
		p->hyst = atoi(rad + 1);
	else
		p->hyst = 99;

	if (comma) {
		nmea_coord(&p->lat, arg, comma[-1]);
		nmea_coord(&p->lon, comma + 1, strend(arg)[-1]);
	}
}

#if 0
		hotspots_crossed(); /* preset current inside/outside status */

		...

		if (meters_travelled && hotspots_crossed_any())
			sendnow = TRUE;

		...
#endif

